Dominating set


In graph theory, a dominating set for a graph G = is a subset D of V such that every vertex not in D is adjacent to at least one member of D. The domination number γ is the number of vertices in a smallest dominating set for G.
The dominating set problem concerns testing whether γ ≤ K for a given graph G and input K; it is a classical NP-complete decision problem in computational complexity theory. Therefore it is believed that there may be no efficient algorithm that finds a smallest dominating set for all graphs, although there are efficient approximation algorithms, as well as both efficient and exact algorithms for certain graph classes.
Figures – on the right show three examples of dominating sets for a graph. In each example, each white vertex is adjacent to at least one red vertex, and it is said that the white vertex is dominated by the red vertex. The domination number of this graph is 2: the examples and show that there is a dominating set with 2 vertices, and it can be checked that there is no dominating set with only 1 vertex for this graph.

History

The domination problem was studied from the 1950s onwards, but the rate of research on domination significantly increased in the mid-1970s. In 1972, Richard Karp proved the set cover problem to be NP-complete. This had immediate implications for the dominating set problem, as there are straightforward vertex to set and edge to non-disjoint-intersection bijections between the two problems. This proved the dominating set problem to be NP-complete as well.
Dominating sets are of practical interest in several areas. In wireless networking, dominating sets are used to find efficient routes within ad-hoc mobile networks. They have also been used in document summarization, and in designing secure systems for electrical grids.

Independent domination

Dominating sets are closely related to independent sets: an independent set is also a dominating set if and only if it is a maximal independent set, so any maximal independent set in a graph is necessarily also a minimal dominating set. Thus, the smallest maximal independent set is greater or equal in size than the smallest independent dominating set. The independent domination number i of a graph G is the size of the smallest independent dominating set.
The minimum dominating set in a graph will not necessarily be independent, but the size of a minimum dominating set is always less than or equal to the size of a minimum maximal independent set, that is, γ ≤ i.
There are graph families in which a minimum maximal independent set is a minimum dominating set. For example, γ = i if G is a claw-free graph.
A graph G is called a domination-perfect graph if γ = i in every induced subgraph H of G. Since an induced subgraph of a claw-free graph is claw-free, it follows that every claw-free graphs is also domination-perfect.

Examples

Figures and are independent dominating sets, while figure illustrates a dominating set that is not an independent set.
For any graph G, its line graph L is claw-free, and hence a minimum maximal independent set in L is also a minimum dominating set in L. An independent set in L corresponds to a matching in G, and a dominating set in L corresponds to an edge dominating set in G. Therefore a minimum maximal matching has the same size as a minimum edge dominating set.
The following example illustrates that strict inequality can hold for γ ≤ i. Let G
be the double star graph consisting of vertices x_1,..., x_p, a, b, y_1,..., y_q, where p, q > 1. The edges of G are defined as follows: each x_i is adjacent to a, a is adjacent to b, and b is adjacent to each b_j. Then γ = 2 since is a minimal vertex domination set. If p ≤ q, then i = p + 1 since a smallest maximal independent set.

Algorithms and computational complexity

The set cover problem is a well-known NP-hard problem – the decision version of set covering was one of Karp's 21 NP-complete problems. There exist a pair of polynomial-time L-reductions between the minimum dominating set problem and the set cover problem. These reductions show that an efficient algorithm for the minimum dominating set problem would provide an efficient algorithm for the set cover problem, and vice versa. Moreover, the reductions preserve the approximation ratio: for any α, a polynomial-time α-approximation algorithm for minimum dominating sets would provide a polynomial-time α-approximation algorithm for the set cover problem and vice versa. Both problems are in fact Log-APX-complete.
The approximability of set covering is also well understood: a logarithmic approximation factor can be found by using a simple greedy algorithm, and finding a sublogarithmic approximation factor is NP-hard. More specifically, the greedy algorithm provides a factor 1 + log |V| approximation of a minimum dominating set, and no polynomial time algorithm can achieve an approximation factor better than c log |V| for some c > 0 unless P = NP.

L-reductions

The following two reductions show that the minimum dominating set problem and the set cover problem are equivalent under L-reductions: given an instance of one problem, we can construct an equivalent instance of the other problem.
From dominating set to set covering.
Given a graph G = with V = , construct a set cover instance as follows: the universe U is V, and the family of subsets is S = such that Sv consists of the vertex v and all vertices adjacent to v in G.
Now if D is a dominating set for G, then C = is a feasible solution of the set cover problem, with |C| = |D|. Conversely, if C = is a feasible solution of the set cover problem, then D is a dominating set for G, with |D| = |C|.
Hence the size of a minimum dominating set for G equals the size of a minimum set cover for. Furthermore, there is a simple algorithm that maps a dominating set to a set cover of the same size and vice versa. In particular, an efficient α-approximation algorithm for set covering provides an efficient α-approximation algorithm for minimum dominating sets.
From set covering to dominating set.
Let be an instance of the set cover problem with the universe U and the family of subsets S = ; we assume that U and the index set I are disjoint. Construct a graph G = as follows: the set of vertices is V = I ∪ U, there is an edge ∈ E between each pair i, j ∈ I, and there is also an edge for each i ∈ I and u ∈ Si. That is, G is a split graph: I is a clique and U is an independent set.
Now if C = is a feasible solution of the set cover problem for some subset D ⊆ I, then D is a dominating set for G, with |D| = |C|: First, for each u ∈ U there is an i ∈ D such that u ∈ Si, and by construction, u and i are adjacent in G; hence u is dominated by i. Second, since D must be nonempty, each i ∈ I is adjacent to a vertex in D.
Conversely, let D be a dominating set for G. Then it is possible to construct another dominating set X such that |X| ≤ |D| and X ⊆ I: simply replace each u ∈ D ∩ U by a neighbour i ∈ I of u. Then C = is a feasible solution of the set cover problem, with |C| = |X| ≤ |D|.

Special cases

If the graph has maximum degree Δ, then the greedy approximation algorithm finds an O-approximation of a minimum dominating set. Also, let dg be the cardinality of dominating set obtained using greedy approximation then following relation holds,, where N is number of nodes and M is number of edges in given undirected graph. For fixed Δ, this qualifies as a dominating set for APX membership; in fact, it is APX-complete.
The problem admits a polynomial-time approximation scheme for special cases such as unit disk graphs and planar graphs. A minimum dominating set can be found in linear time in series-parallel graphs.

Exact algorithms

A minimum dominating set of an n-vertex graph can be found in time O by inspecting all vertex subsets. show how to find a minimum dominating set in time O and exponential space, and in time O and polynomial space. A faster algorithm, using O time was found by, who also show that the number of minimum dominating sets can be computed in this time. The number of minimal dominating sets is at most 1.7159n and all such sets can be listed in time O.

Parameterized complexity

Finding a dominating set of size k plays a central role in the theory of parameterized complexity. It is the most well-known problem complete for the class W|W and used in many reductions to show intractability of other problems. In particular, the problem is not fixed-parameter tractable in the sense that no algorithm with running time fnO for any function f exists unless the W-hierarchy collapses to FPT=W.
On the other hand, if the input graph is planar, the problem remains NP-hard, but a fixed-parameter algorithm is known. In fact, the problem has a kernel of size linear in k, and running times that are exponential in and cubic in n may be obtained by applying dynamic programming to a branch-decomposition of the kernel. More generally, the dominating set problem and many variants of the problem are fixed-parameter tractable when parameterized by both the size of the dominating set and the size of the smallest forbidden complete bipartite subgraph; that is, the problem is FPT on biclique-free graphs, a very general class of sparse graphs that includes the planar graphs.
The complementary set to a dominating set, a nonblocker, can be found by a fixed-parameter algorithm on any graph.

Variants

relates the domination number of a cartesian product of graphs to the domination number of its factors.
There has been much work on connected dominating sets. If S is a connected dominating set, one can form a spanning tree of G in which S forms the set of non-leaf vertices of the tree; conversely, if T is any spanning tree in a graph with more than two vertices, the non-leaf vertices of T form a connected dominating set. Therefore, finding minimum connected dominating sets is equivalent to finding spanning trees with the maximum possible number of leaves.
A total dominating set is a set of vertices such that all vertices in the graph have a neighbor in the dominating set. Figure above shows a dominating set that is a connected dominating set and a total dominating set; the examples in figures and are neither.
A k-tuple dominating set is a set of vertices such that each vertex in the graph has at least k neighbors in the set. An -approximation of a minimum k-tuple dominating set can be found in polynomial time. Similarly, a k-dominating set is a set of vertices such that each vertex not in the set has at least k neighbors in the set. While every graph admits a k-dominating set, only graphs with minimum degree k − 1 admit a k-tuple dominating set. However, even if the graph admits k-tuple dominating set, a minimum k-tuple dominating set can be nearly k times as large as a minimum k-dominating set for the same graph; An -approximation of a minimum k-dominating set can be found in polynomial time as well.
A domatic partition is a partition of the vertices into disjoint dominating sets. The domatic number is the maximum size of a domatic partition.
An eternal dominating set is a dynamic version of domination in which a vertex v in dominating set D is chosen and replaced with a neighbor u such that the modified D is also a dominating set and this process can be repeated over any infinite sequence of choices of vertices v.